#!/bin/sh
[ -z "$1" ] && echo "Error: should be run by udhcpc" && exit 1
+
. /etc/functions.sh
include /lib/network
-
RESOLV_CONF="/tmp/resolv.conf.auto"
-hotplug_event() {
- scan_interfaces
- for ifc in $interfaces; do
- config_get ifname $ifc ifname
- [ "$ifname" = "$interface" ] || continue
+change_state () {
+ [ -n "$ifc" ] || return
+ uci_revert_state "$1" "$2" "$3" "$4"
+ uci_set_state "$1" "$2" "$3" "$4"
+}
- config_get proto $ifc proto
- [ "$proto" = "dhcp" ] || continue
- [ ifup = "$1" ] && {
- uci set "/var/state/network.$ifc.ipaddr=$ip"
- uci set "/var/state/network.$ifc.netmask=${subnet:-255.255.255.0}"
- uci set "/var/state/network.$ifc.dnsdomain=$domain"
- uci set "/var/state/network.$ifc.dns=$dns"
- uci set "/var/state/network.$ifc.gateway=$router"
- }
- env -i ACTION="$1" INTERFACE="$ifc" DEVICE="$ifname" PROTO=dhcp /sbin/hotplug-call iface
- done
+uci_get() {
+ [ -n "$ifc" ] || return
+ uci -P /dev/null get "$1" 2>/dev/null
}
-case "$1" in
- deconfig)
- ifconfig $interface 0.0.0.0
- hotplug_event ifdown
- ;;
- renew|bound)
- ifconfig $interface $ip \
- netmask ${subnet:-255.255.255.0} \
- broadcast ${broadcast:-+}
-
- [ -n "$router" ] && {
- for i in $router ; do
- echo "adding router $i"
- route add default gw $i dev $interface
- valid="$valid|$i"
-
- done
-
- echo "deleting old routes"
- $(route -n | awk '/^0.0.0.0\W{9}('$valid')\W/ {next} /^0.0.0.0/ {print "route del -net "$1" gw "$2";"}')
- }
-
- [ -n "$dns" ] && {
- echo -n > "${RESOLV_CONF}.tmp"
- ${domain:+echo search $domain} >> "${RESOLV_CONF}.tmp"
- for i in $dns ; do
- echo "adding dns $i"
- echo "nameserver $i" >> "${RESOLV_CONF}.tmp"
- done
- mv "${RESOLV_CONF}.tmp" "$RESOLV_CONF"
- }
-
- hotplug_event ifup
+setup_interface () {
+ local old_ip
+ local old_broadcast
+ local old_subnet
+ local old_router
+ local old_dns
+ local user_dns
+ local user_router
+
+ [ -n "$ifc" ] && {
+ config_get old_ip "$ifc" ipaddr
+ config_get old_broadcast "$ifc" broadcast
+ config_get old_subnet "$ifc" netmask
+ }
+
+ [ "$ip" != "$old_ip" ] \
+ || [ "${broadcast:-+}" != "$old_broadcast" ] \
+ || [ "${subnet:-255.255.255.0}" != "$old_subnet" ] && {
+ echo "udhcpc: ifconfig $interface $ip netmask ${subnet:-255.255.255.0} broadcast ${broadcast:-+}"
+ ifconfig $interface $ip netmask ${subnet:-255.255.255.0} broadcast ${broadcast:-+}
+
+ change_state network "$ifc" ipaddr "$ip"
+ change_state network "$ifc" broadcast "${broadcast:-+}"
+ change_state network "$ifc" netmask "${subnet:-255.255.255.0}"
+ }
+
+
+ # Default Route
+ [ -n "$ifc" ] && {
+ change_state network "$ifc" lease_gateway "$router"
+ config_get old_router "$ifc" gateway
+ user_router=$(uci_get "network.$ifc.gateway")
+ [ -n "$user_router" ] && router="$user_router"
+ }
+
+ [ -n "$router" ] && [ "$router" != "0.0.0.0" ] && [ "$router" != "255.255.255.255" ] && [ "$router" != "$old_router" ] && {
+ echo "udhcpc: setting default routers: $router"
+
+ local valid_gw=""
+ for i in $router ; do
+ route add default gw $i dev $interface
+ valid_gw="${valid_gw:+$valid_gw|}$i"
+ done
- # user rules
- [ -f /etc/udhcpc.user ] && . /etc/udhcpc.user
- ;;
-esac
+ eval $(route -n | awk '
+ /^0.0.0.0\W{9}('$valid_gw')\W/ {next}
+ /^0.0.0.0/ {print "route del -net "$1" gw "$2";"}
+ ')
+
+ change_state network "$ifc" gateway "$router"
+ }
+
+ # CIDR STATIC ROUTES (rfc3442)
+ [ -n "$cidrroute" ] && {
+ # This defines how many CIDR Routes can be assigned so that we do not enter
+ # an endless loop on malformed data
+ MAXCIDRROUTES=24;
+ while [ ${MAXCIDRROUTES} -gt "0" ]; do
+ # Format is
+ # $MASK $NW $GW
+ # $NW == AAA.BBB.CCC.DDD
+ # $GW == EEE.FFF.CCC.DDD
+ # $MASK AAA.[BBB].[CCC].[DDD] EEE.FFF.GGG.HHH
+ # 1 2 3 4 5 6 7 8 9
+ MASK=$(echo $cidrroute | awk '{ print $1 }')
+ if [ ${MASK} = "0" ] ; then
+ # $MASK EEE.FFF.GGG.HHH
+ # 1 2 3 5 6
+ NW="0"
+ GW=$(echo $cidrroute | awk '{ print $2"."$3"."$4"."$5 }' )
+ elif [ ${MASK} -le "8" ] ; then
+ # $MASK AAA EEE.FFF.GGG.HHH
+ # 1 2 3 5 6 7
+ NW=$(echo $cidrroute | awk '{ print $2 }' )
+ GW=$(echo $cidrroute | awk '{ print $3"."$4"."$5"."$6 }' )
+ elif [ ${MASK} -le "16" ] ; then
+ # $MASK AAA.BBB EEE.FFF.GGG.HHH
+ # 1 2 3 5 6 7 8
+ NW=$(echo $cidrroute | awk '{ print $2"."$3 }' )
+ GW=$(echo $cidrroute | awk '{ print $4"."$5"."$6"."$7 }' )
+ elif [ ${MASK} -le "24" ] ; then
+ # $MASK AAA.BBB.CCC EEE.FFF.GGG.HHH
+ # 1 2 3 4 5 6 7 8
+ NW=$(echo $cidrroute | awk '{ print $2"."$3"."$4 }' )
+ GW=$(echo $cidrroute | awk '{ print $5"."$6"."$7"."$8 }' )
+
+ else
+ # $MASK AAA.BBB.CCC.DDD EEE.FFF.GGG.HHH
+ # 1 2 3 4 5 6 7 8 9
+ NW=$(echo $cidrroute | awk '{ print $2"."$3"."$4"."$5 }' )
+ GW=$(echo $cidrroute | awk '{ print $6"."$7"."$8"."$9 }' )
+ fi
+ echo [$ROUTECOUNTER] Route Network: $NW/$MASK Gateway: $GW on $interface
+
+ # TODO: Check for malformed data here to eliminate counter workaround
+ # Malformed data is: ... or xxx... or xxx.yyy.. or xxx.yyy.zzz.
+
+ [ -n "$NW" ] && [ -n "$GW" ] && {
+ route add $NW gw $GW dev $interface
+ }
+
+ # Clear the strings incase they don't get set next time around
+ if [ ${NW} = "0" ]; then
+ NW=""
+ fi
+ TMP="$MASK $NW $GW "
+ NW=""
+ GW=""
+
+ # Remove the '.' so that we can delete them from the input with sed
+ TMP=$(echo $TMP | sed "s/\./ /g")
+
+ # Remove the previous entry from cidrroute
+ cidrroute=$(echo $cidrroute | sed "s/$TMP//g")
+
+ # Add to counter
+ let ROUTECOUNTER=$ROUTECOUNTER+1;
+ let MAXCIDRROUTES=$MAXCIDRROUTES-1;
+
+ # Leave the loop if cidrroutes is empty (we've parsed everything)
+ [ ! -n "$cidrroute" ] && break
+
+ done
+
+ echo "done."
+ }
+
+ # DNS
+ config_get old_dns "$ifc" dns
+ user_dns=$(uci_get "network.$ifc.dns")
+ [ -n "$user_dns" ] && dns="$user_dns"
+
+ [ -n "$dns" ] && [ ! -s "${RESOLV_CONF}" -o "$dns" != "$old_dns" ] && {
+ echo "udhcpc: setting dns servers: $dns"
+ echo -n > "${RESOLV_CONF}.tmp"
+ for i in $dns ; do
+ echo "nameserver $i" >> "${RESOLV_CONF}.tmp"
+ done
+ ${domain:+echo search $domain} >> "${RESOLV_CONF}.tmp"
+ mv "${RESOLV_CONF}.tmp" "$RESOLV_CONF"
+
+ change_state network "$ifc" dnsdomain "$domain"
+ change_state network "$ifc" dns "$dns"
+ }
+
+ [ -n "$ifc" ] || return
+
+ # UCI State
+ change_state network "$ifc" lease_server "$serverid"
+ change_state network "$ifc" lease_acquired "$(date '+%s')"
+ change_state network "$ifc" lease_lifetime "$lease"
+ [ -n "$ntpsrv" ] && change_state network "$ifc" lease_ntpsrv "$ntpsrv"
+ [ -n "$timesvr" ] && change_state network "$ifc" lease_timesrv "$timesvr"
+ [ -n "$hostname" ] && change_state network "$ifc" lease_hostname "$hostname"
+ [ -n "$timezone" ] && change_state network "$ifc" lease_timezone "$timezone"
+
+
+ # Hotplug
+ env -i ACTION="$1" INTERFACE="$ifc" DEVICE="$ifname" PROTO=dhcp /sbin/hotplug-call iface
+}
+
+
+scan_interfaces
+applied=
+for ifc in $interfaces __default; do
+ if [ "$ifc" = __default ]; then
+ ifc=""
+ [ -n "$applied" ] && continue
+ else
+ config_get ifname "$ifc" ifname
+ [ "$ifname" = "$interface" ] || continue
+
+ config_get proto "$ifc" proto
+ [ "$proto" = "dhcp" ] || continue
+ applied=true
+ fi
+
+ case "$1" in
+ deconfig)
+ ifconfig "$interface" 0.0.0.0
+ [ -n "$ifc" ] && {
+ env -i ACTION="ifdown" INTERFACE="$ifc" DEVICE="$ifname" PROTO=dhcp /sbin/hotplug-call iface
+
+ config_get device "$ifc" device
+ config_get ifname "$ifc" ifname
+ config_get aliases "$ifc" aliases
+ uci_revert_state network "$ifc"
+ [ -n "$device" ] && uci_set_state network "$ifc" device "$device"
+ [ -n "$ifname" ] && uci_set_state network "$ifc" ifname "$ifname"
+ [ -n "$aliases" ] && uci_set_state network "$ifc" aliases "$aliases"
+ }
+ ;;
+ renew)
+ setup_interface update
+ ;;
+ bound)
+ setup_interface ifup
+ ;;
+ esac
+done
+
+# user rules
+[ -f /etc/udhcpc.user ] && . /etc/udhcpc.user
exit 0